regina::NLayeredTorusBundle Class Reference
Standard Triangulations and Subcomplexes

Describes a layered torus bundle. More...

`#include <subcomplex/nlayeredsurfacebundle.h>`

Inheritance diagram for regina::NLayeredTorusBundle:

## Public Member Functions

virtual | ~NLayeredTorusBundle ()
| Destroys this layered torus bundle and all of its internal components. More...
const NTxICore & | core () const
| Returns the `T x I` triangulation at the core of this layered surface bundle. More...
const NIsomorphism * | coreIso () const
| Returns the isomorphism describing how the core `T x I` appears as a subcomplex of this layered surface bundle. More...
const NMatrix2 & | layeringReln () const
| Returns a 2-by-2 matrix describing how the layering of tetrahedra relates curves on the two torus boundaries of the core `T x I`. More...
NManifold * | getManifold () const
| Returns the 3-manifold represented by this triangulation, if such a recognition routine has been implemented. More...
NAbelianGroup * | getHomologyH1 () const
| Returns the expected first homology group of this triangulation, if such a routine has been implemented. More...
std::ostream & | writeName (std::ostream &out) const
| Writes the name of this triangulation as a human-readable string to the given output stream. More...
std::ostream & | writeTeXName (std::ostream &out) const
| Writes the name of this triangulation in TeX format to the given output stream. More...
void | writeTextLong (std::ostream &out) const
| Writes this object in long text format to the given output stream. More...
Public Member Functions inherited from regina::NStandardTriangulation
virtual | ~NStandardTriangulation ()
| A destructor that does nothing. More...
std::string | getName () const
| Returns the name of this specific triangulation as a human-readable string. More...
std::string | getTeXName () const
| Returns the name of this specific triangulation in TeX format. More...
virtual void | writeTextShort (std::ostream &out) const
| Writes this object in short text format to the given output stream. More...
Public Member Functions inherited from regina::ShareableObject
| ShareableObject ()
| Default constructor that does nothing. More...
virtual | ~ShareableObject ()
| Default destructor that does nothing. More...
std::string | str () const
| Returns the output from writeTextShort() as a string. More...
std::string | toString () const
| A deprecated alias for str(), which returns the output from writeTextShort() as a string. More...
std::string | detail () const
| Returns the output from writeTextLong() as a string. More...
std::string | toStringLong () const
| A deprecated alias for detail(), which returns the output from writeTextLong() as a string. More...

## Static Public Member Functions

static NLayeredTorusBundle * | isLayeredTorusBundle (NTriangulation *tri)
| Determines if the given triangulation is a layered surface bundle. More...
Static Public Member Functions inherited from regina::NStandardTriangulation
static NStandardTriangulation * | isStandardTriangulation (NComponent *component)
| Determines whether the given component represents one of the standard triangulations understood by Regina. More...
static NStandardTriangulation * | isStandardTriangulation (NTriangulation *tri)
| Determines whether the given triangulation represents one of the standard triangulations understood by Regina. More...

## Additional Inherited Members

Protected Member Functions inherited from regina::boost::noncopyable
| noncopyable ()
| A constructor which does nothing. More...
| ~noncopyable ()
| A destructor which does nothing. More...

## Detailed Description

Describes a layered torus bundle.

This is a triangulation of a torus bundle over the circle formed as follows.

We begin with a thin I-bundle over the torus, i.e,. a triangulation of the product `T x I` that is only one tetrahedron thick. This is referred to as the core, and is described by an object of type NTxICore.

We then identify the upper and lower torus boundaries of this core according to some homeomorphism of the torus. This may be impossible due to incompatible boundary edges, and so we allow a layering of tetrahedra over one of the boundari tori in order to adjust the boundary edges accordingly. Layerings are described in more detail in the NLayering class.

Given the parameters of the core `T x I` and the specific layering, the monodromy for this torus bundle over the circle can be calculated. The getManifold() routine returns details of the corresponding 3-manifold.

All optional NStandardTriangulation routines are implemented for this class.

Test:
  Included in the test suite.

## Constructor & Destructor Documentation

virtual regina::NLayeredTorusBundle::~NLayeredTorusBundle | ( |  | ) |

virtual

Destroys this layered torus bundle and all of its internal components.

## Member Function Documentation

const NTxICore & regina::NLayeredTorusBundle::core | ( |  | ) | const

inline

Returns the `T x I` triangulation at the core of this layered surface bundle.

This is the product `T x I` whose boundaries are joined (possibly via some layering of tetrahedra).

Note that the triangulation returned by NTxICore::core() (that is, NLayeredSurfaceBundle::core().core()) may well use different tetrahedron and vertex numbers. That is, an isomorphic copy of it appears within this layered surface bundle but the individual tetrahedra and vertices may have been permuted. For a precise mapping from the NTxICore::core() triangulation to this triangulation, see the routine coreIso().

Returns
  the core `T x I` triangulation.

const NIsomorphism * regina::NLayeredTorusBundle::coreIso | ( |  | ) | const

inline

Returns the isomorphism describing how the core `T x I` appears as a subcomplex of this layered surface bundle.

As described in the core() notes, the core `T x I` triangulation returned by NTxICore::core() appears within this layered surface bundle, but not necessarily with the same tetrahedron or vertex numbers.

This routine returns an isomorphism that maps the tetrahedra and vertices of the core `T x I` triangulation (as returned by NLayeredSurfaceBundle::core().core()) to the tetrahedra and vertices of this overall layered surface bundle.

The isomorphism that is returned belongs to this object, and should not be modified or destroyed.

Returns
  the isomorphism from the core `T x I` to this layered surface bundle.

NAbelianGroup* regina::NLayeredTorusBundle::getHomologyH1 | ( |  | ) | const

virtual

Returns the expected first homology group of this triangulation, if such a routine has been implemented.

If the calculation of homology has not yet been implemented for this triangulation then this routine will return 0.

This routine does not work by calling NTriangulation::getHomologyH1() on the associated real triangulation. Instead the homology is calculated directly from the known properties of this standard triangulation.

The details of which standard triangulations have homology calculation routines can be found in the notes for the corresponding subclasses of NStandardTriangulation. The default implementation of this routine returns 0.

The homology group will be newly allocated and must be destroyed by the caller of this routine.

If this NStandardTriangulation describes an entire NTriangulation (and not just a part thereof) then the results of this routine should be identical to the homology group obtained by calling NTriangulation::getHomologyH1() upon the associated real triangulation.

Returns
  the first homology group of this triangulation, or 0 if the appropriate calculation routine has not yet been implemented.

Reimplemented from regina::NStandardTriangulation.

NManifold* regina::NLayeredTorusBundle::getManifold | ( |  | ) | const

virtual

Returns the 3-manifold represented by this triangulation, if such a recognition routine has been implemented.

If the 3-manifold cannot be recognised then this routine will return 0.

The details of which standard triangulations have 3-manifold recognition routines can be found in the notes for the corresponding subclasses of NStandardTriangulation. The default implementation of this routine returns 0.

It is expected that the number of triangulations whose underlying 3-manifolds can be recognised will grow between releases.

The 3-manifold will be newly allocated and must be destroyed by the caller of this routine.

Returns
  the underlying 3-manifold.

Reimplemented from regina::NStandardTriangulation.

static NLayeredTorusBundle* regina::NLayeredTorusBundle::isLayeredTorusBundle | ( | NTriangulation * | tri | ) |

static

Determines if the given triangulation is a layered surface bundle.

Parameters

  tri | the triangulation to examine.

Returns
  a newly created structure containing details of the layered surface bundle, or `null` if the given triangulation is not a layered surface bundle.

const NMatrix2 & regina::NLayeredTorusBundle::layeringReln | ( |  | ) | const

inline

Returns a 2-by-2 matrix describing how the layering of tetrahedra relates curves on the two torus boundaries of the core `T x I`.

The NTxICore class documentation describes generating alpha and beta curves on the two torus boundaries of the core `T x I` (which are referred to as the upper and lower boundaries). The two boundary tori are parallel in two directions: through the core, and through the layering. It is desirable to know the parallel relationship between the two sets of boundary curves in each direction.

The relationship through the core is already described by NTxICore::parallelReln(). This routine describes the relationship through the layering.

Let a_u and b_u be the alpha and beta curves on the upper boundary torus, and let a_l and b_l be the alpha and beta curves on the lower boundary torus. Suppose that the upper alpha is parallel to w.a_l + x.b_l, and that the upper beta is parallel to y.a_l + z.b_l. Then the matrix returned will be

        [ w  x ]
        [      ] .
        [ y  z ]

In other words,

        [ a_u ]                      [ a_l ]
        [     ]  =  layeringReln() * [     ] .
        [ b_u ]                      [ b_l ]

It can be observed that this matrix expresses the upper boundary curves in terms of the lower, whereas NTxICore::parallelReln() expresses the lower boundary curves in terms of the upper. This means that the monodromy describing the overall torus bundle over the circle can be calculated as

        M  =  layeringReln() * core().parallelReln()

or alternatively using the similar matrix

        M'  =  core().parallelReln() * layeringReln() .

Note that in the degenerate case where there is no layering at all, this matrix is still perfectly well defined; in this case it describes a direct identification between the upper and lower boundary tori.

Returns
  the relationship through the layering between the upper and lower boundary curves of the core `T x I`.

std::ostream & regina::NLayeredTorusBundle::writeName | ( | std::ostream & | out | ) | const

inline virtual

Writes the name of this triangulation as a human-readable string to the given output stream.

Python:
  The parameter out does not exist; standard output will be used.

Parameters

  out | the output stream to which to write.

Returns
  a reference to the given output stream.

Implements regina::NStandardTriangulation.

std::ostream & regina::NLayeredTorusBundle::writeTeXName | ( | std::ostream & | out | ) | const

inline virtual

Writes the name of this triangulation in TeX format to the given output stream.

No leading or trailing dollar signs will be included.

Warning
  The behaviour of this routine has changed as of Regina 4.3; in earlier versions, leading and trailing dollar signs were provided.

Python:
  The parameter out does not exist; standard output will be used.

Parameters

  out | the output stream to which to write.

Returns
  a reference to the given output stream.

Implements regina::NStandardTriangulation.

void regina::NLayeredTorusBundle::writeTextLong | ( | std::ostream & | out | ) | const

virtual

Writes this object in long text format to the given output stream.

The output should provide the user with all the information they could want. The output should be human-readable, should not contain extremely long lines (so users can read the output in a terminal), and should end with a final newline.

The default implementation of this routine merely calls writeTextShort() and adds a newline.

Python:
  The parameter out does not exist; standard output will be used.

Parameters

  out | the output stream to which to write.

Reimplemented from regina::ShareableObject.

The documentation for this class was generated from the following file:

- subcomplex/nlayeredsurfacebundle.h

Copyright © 1999-2013, The Regina development team
This software is released under the GNU General Public License, with some additional permissions; see the source code for details.
For further information, or to submit a bug or other problem, please contact Ben Burton (bab@debian.org).